lxc.sh 14 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491
  1. #!/usr/bin/env bash
  2. # -*- coding: utf-8; mode: sh indent-tabs-mode: nil -*-
  3. # SPDX-License-Identifier: AGPL-3.0-or-later
  4. # shellcheck source=utils/lib.sh
  5. source "$(dirname "${BASH_SOURCE[0]}")/lib.sh"
  6. source_dot_config
  7. # load environment of the LXC suite
  8. LXC_ENV="${LXC_ENV:-${REPO_ROOT}/utils/lxc-searx.env}"
  9. source "$LXC_ENV"
  10. lxc_set_suite_env
  11. # ----------------------------------------------------------------------------
  12. # config
  13. # ----------------------------------------------------------------------------
  14. #
  15. # read also:
  16. # - https://lxd.readthedocs.io/en/latest/
  17. LXC_HOST_PREFIX="${LXC_HOST_PREFIX:-test}"
  18. # where all folders from HOST are mounted
  19. LXC_SHARE_FOLDER="/share"
  20. LXC_REPO_ROOT="${LXC_SHARE_FOLDER}/$(basename "${REPO_ROOT}")"
  21. ubu1604_boilerplate="
  22. export DEBIAN_FRONTEND=noninteractive
  23. apt-get update -y
  24. apt-get upgrade -y
  25. apt-get install -y git curl wget
  26. "
  27. ubu1804_boilerplate="$ubu1604_boilerplate"
  28. ubu1904_boilerplate="$ubu1804_boilerplate"
  29. ubu1910_boilerplate="$ubu1904_boilerplate"
  30. # shellcheck disable=SC2034
  31. ubu2004_boilerplate="
  32. $ubu1910_boilerplate
  33. echo 'Set disable_coredump false' >> /etc/sudo.conf
  34. "
  35. # shellcheck disable=SC2034
  36. archlinux_boilerplate="
  37. pacman -Syu --noconfirm
  38. pacman -S --noconfirm git curl wget sudo
  39. echo 'Set disable_coredump false' >> /etc/sudo.conf
  40. "
  41. # shellcheck disable=SC2034
  42. fedora31_boilerplate="
  43. dnf update -y
  44. dnf install -y git curl wget hostname
  45. echo 'Set disable_coredump false' >> /etc/sudo.conf
  46. "
  47. REMOTE_IMAGES=()
  48. CONTAINERS=()
  49. LOCAL_IMAGES=()
  50. for ((i=0; i<${#LXC_SUITE[@]}; i+=2)); do
  51. REMOTE_IMAGES=("${REMOTE_IMAGES[@]}" "${LXC_SUITE[i]}")
  52. CONTAINERS=("${CONTAINERS[@]}" "${LXC_HOST_PREFIX}-${LXC_SUITE[i+1]}")
  53. LOCAL_IMAGES=("${LOCAL_IMAGES[@]}" "${LXC_SUITE[i+1]}")
  54. done
  55. HOST_USER="${SUDO_USER:-$USER}"
  56. HOST_USER_ID=$(id -u "${HOST_USER}")
  57. HOST_GROUP_ID=$(id -g "${HOST_USER}")
  58. # ----------------------------------------------------------------------------
  59. usage() {
  60. # ----------------------------------------------------------------------------
  61. _cmd="$(basename "$0")"
  62. cat <<EOF
  63. usage::
  64. $_cmd build [containers]
  65. $_cmd copy [images]
  66. $_cmd remove [containers|<name>|images]
  67. $_cmd [start|stop] [containers|<name>]
  68. $_cmd show [info|config|suite|images]
  69. $_cmd cmd [--|<name>] '...'
  70. $_cmd install [suite|base]
  71. build
  72. :containers: build, launch and 'install basic' packages on 'containers'
  73. copy:
  74. :images: copy remote images of the suite into local storage
  75. remove
  76. :containers: delete all 'containers' or only <container-name>
  77. :images: delete local images of the suite
  78. start/stop
  79. :containers: start/stop all 'containers' from the suite
  80. :<name>: start/stop conatiner <name> from suite
  81. show
  82. :info: show info of all the containers from LXC suite
  83. :config: show config of all the containers from the LXC suite
  84. :suite: show services of all the containers from the LXC suite
  85. :images: show information of local images
  86. cmd
  87. use single qoutes to evaluate in container's bash, e.g. 'echo $(hostname)'
  88. -- run command '...' in all containers of the LXC suite
  89. :<name>: run command '...' in container <name>
  90. install
  91. :suite: install LXC suite; ${LXC_SUITE_INSTALL_INFO}
  92. :base: prepare LXC; install basic packages
  93. EOF
  94. usage_images
  95. echo
  96. usage_containers
  97. echo
  98. [ -n "${1+x}" ] && err_msg "$1"
  99. }
  100. usage_containers() {
  101. cat <<EOF
  102. LXC suite containers:
  103. $(echo " ${CONTAINERS[*]}" | $FMT)
  104. EOF
  105. [ -n "${1+x}" ] && err_msg "$1"
  106. }
  107. usage_images() {
  108. cat <<EOF
  109. LXC suite images:
  110. $(echo " ${LOCAL_IMAGES[*]}" | $FMT)
  111. EOF
  112. }
  113. lxd_info() {
  114. cat <<EOF
  115. LXD is needed, to install run::
  116. snap install lxd
  117. lxd init --auto
  118. EOF
  119. }
  120. main() {
  121. local exit_val
  122. local _usage="unknown or missing $1 command $2"
  123. # don't check prerequisite when in recursion
  124. if [[ ! $1 == __* ]]; then
  125. if ! in_container; then
  126. ! required_commands lxc && lxd_info && exit 42
  127. fi
  128. [[ -z $LXC_SUITE ]] && err_msg "missing LXC_SUITE" && exit 42
  129. fi
  130. case $1 in
  131. --source-only) ;;
  132. -h|--help) usage; exit 0;;
  133. build)
  134. sudo_or_exit
  135. case $2 in
  136. ''|containers) build_instances ;;
  137. *) usage "$_usage"; exit 42;;
  138. esac
  139. ;;
  140. copy)
  141. case $2 in
  142. ''|images) lxc_copy_images_localy;;
  143. *) usage "$_usage"; exit 42;;
  144. esac
  145. ;;
  146. remove)
  147. sudo_or_exit
  148. case $2 in
  149. ''|containers) remove_instances ;;
  150. images) lxc_delete_images_localy ;;
  151. ${LXC_HOST_PREFIX}-*)
  152. ! lxc_exists "$2" && usage_containers "unknown container: $2" && exit 42
  153. if ask_yn "Do you really want to delete conatiner $2"; then
  154. lxc_delete_container "$2"
  155. fi
  156. ;;
  157. *) usage "uknown or missing container <name> $2"; exit 42;;
  158. esac
  159. ;;
  160. start|stop)
  161. sudo_or_exit
  162. case $2 in
  163. ''|containers) lxc_cmd "$1" ;;
  164. ${LXC_HOST_PREFIX}-*)
  165. ! lxc_exists "$2" && usage_containers "unknown container: $2" && exit 42
  166. info_msg "lxc $1 $2"
  167. lxc "$1" "$2" | prefix_stdout "[${_BBlue}${i}${_creset}] "
  168. ;;
  169. *) usage "uknown or missing container <name> $2"; exit 42;;
  170. esac
  171. ;;
  172. show)
  173. sudo_or_exit
  174. case $2 in
  175. suite) show_suite ;;
  176. images) show_images ;;
  177. config)
  178. rst_title "container configurations"
  179. echo
  180. lxc list "$LXC_HOST_PREFIX-"
  181. echo
  182. lxc_cmd config show
  183. ;;
  184. info)
  185. rst_title "container info"
  186. echo
  187. lxc_cmd info
  188. ;;
  189. *) usage "$_usage"; exit 42;;
  190. esac
  191. ;;
  192. __show)
  193. # wrapped show commands, called once in each container
  194. case $2 in
  195. suite) lxc_suite_info ;;
  196. esac
  197. ;;
  198. cmd)
  199. sudo_or_exit
  200. shift
  201. case $1 in
  202. --) shift; lxc_exec "$@" ;;
  203. ${LXC_HOST_PREFIX}-*)
  204. ! lxc_exists "$1" && usage_containers "unknown container: $1" && exit 42
  205. local name=$1
  206. shift
  207. lxc_exec_cmd "${name}" "$@"
  208. ;;
  209. *) usage "uknown or missing container <name> $1"; exit 42;;
  210. esac
  211. ;;
  212. install)
  213. sudo_or_exit
  214. case $2 in
  215. suite|base)
  216. lxc_exec "${LXC_REPO_ROOT}/utils/lxc.sh" __install "$2"
  217. ;;
  218. *) usage "$_usage"; exit 42 ;;
  219. esac
  220. ;;
  221. __install)
  222. # wrapped install commands, called once in each container
  223. # shellcheck disable=SC2119
  224. case $2 in
  225. suite) lxc_suite_install ;;
  226. base) FORCE_TIMEOUT=0 lxc_install_base_packages ;;
  227. esac
  228. ;;
  229. doc)
  230. echo
  231. echo ".. generic utils/lxc.sh documentation"
  232. ;;
  233. -*) usage "unknown option $1"; exit 42;;
  234. *) usage "unknown or missing command $1"; exit 42;;
  235. esac
  236. }
  237. build_instances() {
  238. rst_title "Build LXC instances"
  239. lxc_copy_images_localy
  240. echo
  241. rst_title "build containers" section
  242. echo
  243. lxc_init_containers
  244. lxc_config_containers
  245. lxc_boilerplate_containers
  246. echo
  247. lxc_exec "${LXC_REPO_ROOT}/utils/lxc.sh" __install base
  248. echo
  249. lxc list "$LXC_HOST_PREFIX"
  250. }
  251. remove_instances() {
  252. rst_title "Remove LXC instances"
  253. rst_para "existing containers matching ${_BGreen}$LXC_HOST_PREFIX-*${_creset}"
  254. echo
  255. lxc list "$LXC_HOST_PREFIX-"
  256. echo -en "\\n${_BRed}LXC containers to delete::${_creset}\\n\\n ${CONTAINERS[*]}\\n" | $FMT
  257. if ask_yn "Do you really want to delete these conatiners"; then
  258. for i in "${CONTAINERS[@]}"; do
  259. lxc_delete_container "$i"
  260. done
  261. fi
  262. echo
  263. lxc list "$LXC_HOST_PREFIX-"
  264. }
  265. # images
  266. # ------
  267. lxc_copy_images_localy() {
  268. rst_title "copy images" section
  269. echo
  270. for ((i=0; i<${#LXC_SUITE[@]}; i+=2)); do
  271. if lxc_image_exists "local:${LXC_SUITE[i+1]}"; then
  272. info_msg "image ${LXC_SUITE[i]} already copied --> ${LXC_SUITE[i+1]}"
  273. else
  274. info_msg "copy image locally ${LXC_SUITE[i]} --> ${LXC_SUITE[i+1]}"
  275. lxc image copy "${LXC_SUITE[i]}" local: \
  276. --alias "${LXC_SUITE[i+1]}" | prefix_stdout
  277. fi
  278. done
  279. # lxc image list local: && wait_key
  280. }
  281. lxc_delete_images_localy() {
  282. rst_title "Delete LXC images"
  283. rst_para "local existing images"
  284. echo
  285. lxc image list local:
  286. echo -en "\\n${_BRed}LXC images to delete::${_creset}\\n\\n ${LOCAL_IMAGES[*]}\\n"
  287. if ask_yn "Do you really want to delete these images"; then
  288. for i in "${LOCAL_IMAGES[@]}"; do
  289. lxc_delete_local_image "$i"
  290. done
  291. fi
  292. for i in $(lxc image list --format csv | grep '^,' | sed 's/,\([^,]*\).*$/\1/'); do
  293. if ask_yn "Image $i has no alias, do you want to delete the image?" Yn; then
  294. lxc_delete_local_image "$i"
  295. fi
  296. done
  297. echo
  298. lxc image list local:
  299. }
  300. show_images(){
  301. rst_title "local images"
  302. echo
  303. lxc image list local:
  304. echo -en "\\n${_Green}LXC suite images::${_creset}\\n\\n ${LOCAL_IMAGES[*]}\\n"
  305. wait_key
  306. for i in "${LOCAL_IMAGES[@]}"; do
  307. if lxc_image_exists "$i"; then
  308. info_msg "lxc image info ${_BBlue}${i}${_creset}"
  309. lxc image info "$i" | prefix_stdout "[${_BBlue}${i}${_creset}] "
  310. else
  311. warn_msg "image ${_BBlue}$i${_creset} does not yet exists"
  312. fi
  313. done
  314. }
  315. # container
  316. # ---------
  317. show_suite(){
  318. rst_title "LXC suite ($LXC_HOST_PREFIX-*)"
  319. echo
  320. lxc list "$LXC_HOST_PREFIX-"
  321. echo
  322. for i in "${CONTAINERS[@]}"; do
  323. if ! lxc_exists "$i"; then
  324. warn_msg "container ${_BBlue}$i${_creset} does not yet exists"
  325. else
  326. lxc exec -t "${i}" -- "${LXC_REPO_ROOT}/utils/lxc.sh" __show suite \
  327. | prefix_stdout "[${_BBlue}${i}${_creset}] "
  328. echo
  329. fi
  330. done
  331. }
  332. lxc_cmd() {
  333. for i in "${CONTAINERS[@]}"; do
  334. if ! lxc_exists "$i"; then
  335. warn_msg "container ${_BBlue}$i${_creset} does not yet exists"
  336. else
  337. info_msg "lxc $* $i"
  338. lxc "$@" "$i" | prefix_stdout "[${_BBlue}${i}${_creset}] "
  339. echo
  340. fi
  341. done
  342. }
  343. lxc_exec_cmd() {
  344. local name="$1"
  345. shift
  346. exit_val=
  347. info_msg "[${_BBlue}${name}${_creset}] ${_BGreen}${*}${_creset}"
  348. lxc exec -t --cwd "${LXC_REPO_ROOT}" "${name}" -- bash -c "$*"
  349. exit_val=$?
  350. if [[ $exit_val -ne 0 ]]; then
  351. warn_msg "[${_BBlue}${name}${_creset}] exit code (${_BRed}${exit_val}${_creset}) from ${_BGreen}${*}${_creset}"
  352. else
  353. info_msg "[${_BBlue}${name}${_creset}] exit code (${exit_val}) from ${_BGreen}${*}${_creset}"
  354. fi
  355. }
  356. lxc_exec() {
  357. for i in "${CONTAINERS[@]}"; do
  358. if ! lxc_exists "$i"; then
  359. warn_msg "container ${_BBlue}$i${_creset} does not yet exists"
  360. else
  361. lxc_exec_cmd "${i}" "$@" | prefix_stdout "[${_BBlue}${i}${_creset}] "
  362. fi
  363. done
  364. }
  365. lxc_init_containers() {
  366. local image_name
  367. local container_name
  368. for ((i=0; i<${#LXC_SUITE[@]}; i+=2)); do
  369. image_name="${LXC_SUITE[i+1]}"
  370. container_name="${LXC_HOST_PREFIX}-${image_name}"
  371. if lxc info "${container_name}" &>/dev/null; then
  372. info_msg "container '${container_name}' already exists"
  373. else
  374. info_msg "create conatiner instance: ${container_name}"
  375. lxc init "local:${image_name}" "${container_name}"
  376. fi
  377. done
  378. }
  379. lxc_config_containers() {
  380. for i in "${CONTAINERS[@]}"; do
  381. info_msg "[${_BBlue}${i}${_creset}] configure container ..."
  382. info_msg "[${_BBlue}${i}${_creset}] map uid/gid from host to container"
  383. # https://lxd.readthedocs.io/en/latest/userns-idmap/#custom-idmaps
  384. echo -e -n "uid $HOST_USER_ID 0\\ngid $HOST_GROUP_ID 0"\
  385. | lxc config set "$i" raw.idmap -
  386. info_msg "[${_BBlue}${i}${_creset}] share ${REPO_ROOT} (repo_share) from HOST into container"
  387. # https://lxd.readthedocs.io/en/latest/instances/#type-disk
  388. lxc config device add "$i" repo_share disk \
  389. source="${REPO_ROOT}" \
  390. path="${LXC_REPO_ROOT}" &>/dev/null
  391. # lxc config show "$i" && wait_key
  392. done
  393. }
  394. lxc_boilerplate_containers() {
  395. local image_name
  396. local container_name
  397. local boilerplate_script
  398. for ((i=0; i<${#LXC_SUITE[@]}; i+=2)); do
  399. image_name="${LXC_SUITE[i+1]}"
  400. container_name="${LXC_HOST_PREFIX}-${image_name}"
  401. boilerplate_script="${image_name}_boilerplate"
  402. boilerplate_script="${!boilerplate_script}"
  403. info_msg "[${_BBlue}${container_name}${_creset}] init .."
  404. if lxc start -q "${container_name}" &>/dev/null; then
  405. sleep 5 # guest needs some time to come up and get an IP
  406. fi
  407. lxc_init_container "${container_name}"
  408. info_msg "[${_BBlue}${container_name}${_creset}] install /.lxcenv.mk .."
  409. cat <<EOF | lxc exec "${container_name}" -- bash | prefix_stdout "[${_BBlue}${container_name}${_creset}] "
  410. rm -f "/.lxcenv.mk"
  411. ln -s "${LXC_REPO_ROOT}/utils/makefile.lxc" "/.lxcenv.mk"
  412. ls -l "/.lxcenv.mk"
  413. EOF
  414. info_msg "[${_BBlue}${container_name}${_creset}] install boilerplate .."
  415. if lxc start -q "${container_name}" &>/dev/null; then
  416. sleep 5 # guest needs some time to come up and get an IP
  417. fi
  418. if [[ -n "${boilerplate_script}" ]]; then
  419. echo "${boilerplate_script}" \
  420. | lxc exec "${container_name}" -- bash \
  421. | prefix_stdout "[${_BBlue}${container_name}${_creset}] "
  422. else
  423. err_msg "[${_BBlue}${container_name}${_creset}] no boilerplate for image '${image_name}'"
  424. fi
  425. done
  426. }
  427. # ----------------------------------------------------------------------------
  428. main "$@"
  429. # ----------------------------------------------------------------------------